package pop3;
############################################################################
#
#     pop3.pl  v2.02sp
#
# Copyright (c) 1998-2001 Motozo Watanabe <watanabe@bellcall.co.jp>
# Telecom Corporation <http://www.bellcall.co.jp/>
# 23-14 Meieki-2 Nishi-ku Nagoya, 451-0045 Japan
############################################################################

require 'base64.pl';
require 'jcode.pl';

$POP3_port=110;
use Socket;
$sockaddr='S n a4 x8';
$AF_INET=2;
$PROTOCOL=0;
$SOCK_STREAM=1;
if(defined(&main'PF_INET)){$SOCK_STREAM=&main'SOCK_STREAM}
$errorlevel=-1;
sub connectserver{
  if(($name,$aliases,$type,$len,$remote_addr)=gethostbyname($pop3severname)){
    $errorlevel=-3;
    if(socket(remote_POP3,$AF_INET,$SOCK_STREAM,$PROTOCOL)){
      $remote_sin=pack($sockaddr,$AF_INET,$POP3_port,$remote_addr);
      if(connect(remote_POP3,$remote_sin)){return "POP3"}
    }close(remote_POP3)
  }
  return "";
}
sub serveraccess{
  $_=<remote_POP3>;
  return 1 if(/^\+OK/);
  0;
}
sub getmessagelist{
  local($articles);
  $articles=0;
  $_=<remote_POP3>;
  while(<remote_POP3>!~/^\.\r\n/){$articles++}
  $articles;
}
sub jconv{
  local($jconv)=@_;
  local($decode,$count);
  $jconv=~s/\?==\?/\?= =\?/g;
  if($jconv=~/=\?iso-2022-jp\?B\?.+/i){
    @mime=split(/\?=/,$jconv);
    foreach(@mime){
      /=\?iso-2022-jp\?B\?(.+)$/i;
      $jis=&base64'b64decode($1);
      $jis=&jcode'to($code,$jis) if($code ne"jis");
      s/=\?iso-2022-jp\?B\?.+/$jis/i;
      s/\s+//g if($count);
      s/\s+$//g;
      $decode.="$_";
      $count++;
    }
    $jconv=$decode;
  }elsif($jconv=~/=\?shift_jis\?B\?.+/i){
    @mime=split(/\?=/,$jconv);
    foreach(@mime){
      /=\?shift_jis\?B\?(.+)$/i;
      $sjis=&base64'b64decode($1);
      $sjis=&jcode'to($code,$sjis) if($code ne"sjis");
      s/=\?shift_jis\?B\?.+/$sjis/i;
      s/\s+//g if($count);
      s/\s+$//g;
      $decode.="$_";
      $count++;
    }$jconv=$decode;
  }
  else{$jconv=&jcode'to($code,$jconv)}
  $jconv=~s/^\s+//;
  $jconv;
}
sub getlist{
  ($pop3severname,$loginid,$password,$code,$enum)=@_;
  local(*mailbox);
  if(!$pop3severname||!$loginid||!$password){$mailbox{errorcode}="$errorlevel\0";return %mailbox}
  $code="sjis" if(!$code||$code!~/^(euc|jis|sjis)$/);
  $enum=50 if($enum<1||$enum!~/^\d+/);
  if($mailprotocol=&connectserver()){
    &loginserver();
    close(remote_POP3);
    return %mailbox
  }
  $mailbox{errorcode}="$errorlevel\0";
  %mailbox;
}
sub loginserver{
  local($article);
  select(remote_POP3); $|=1; select(STDOUT); $|=1;
  binmode(remote_POP3);
  $_=<remote_POP3>;
  print remote_POP3 "USER $loginid\r\n";
  if(&serveraccess){
  print remote_POP3 "PASS $password\r\n";
  if(&serveraccess){
  print remote_POP3 "LIST\r\n";
  $articles=&getmessagelist;
  if($articles !=0){
  $fetched="Seen";
  $article=0;
  while ($article !=$articles){
  $article=$article+1;
  print remote_POP3 "TOP $article 0\r\n";
  &getheaders() if($enum>=$article&&$cnt<$enum)}}
  else{$mailbox{errorcode}="-2\0"}}
  else{$mailbox{errorcode}="-4\0"}}
  print remote_POP3 "QUIT\r\n";
  &serveraccess;
}
sub getheaders{
  $cnt++;
  $_=<remote_POP3>;
  while($_!~/^\.\r\n/){
    $cont="" if(/^\w/);
    if(/^\+OK (\d+) octets/i){$size=$1}
    elsif(/^message-id: (.+)$/i){$messageid=$1;$messageid=~/<?(.*)\@(.*)>?/;$messageid=$1}
    elsif(/^from: (.+)$/i){$from=$1;$cont=1}elsif(/^\s+(.+)$/&&$cont==1){$from.="$1"}
    elsif(/^to: (.+)$/i){$to=$1;$cont=2}elsif(/^\s+(.+)$/&&$cont==2){$to.="$1"}
    elsif(/^cc: (.+)$/i){$cc=$1;$cont=3}elsif(/^\s+(.+)$/&&$cont==3){$cc.="$1"}
    elsif(/^reply-to: (.+)/i){$replyto=$1;$cont=4}elsif(/^\s+(.+)$/&&$cont==4){$replyto.="$1"}
    elsif(/^subject: (.+)$/i){$subject=$1;$cont=5}elsif(/^\s+(.+)$/&&$cont==5){$subject.="$1"}
    if(/^date: (.+\d{1,2}:\d{2}:\d{2}).*$/i){$date=$1;$date=~s/\r\n|\r|\n//g;$date=~s/, /,/;$date=~s/\+0900//}
    elsif(/^mime-version: (.+)$/i){$mimeversion=$1}
    if(/^content-type: (.+)$/i){$basecontenttype=$1}
    if(/boundary=(.+)$/i){$boundary="$1";$boundary=~s/"//g}
    $_=<remote_POP3>;
  }
  $from=~s/\"//g;
  $from=&jconv($from) if($from);
  $to=&jconv($to) if($to);
  $cc=&jconv($cc) if($cc);
  $replyto=&jconv($replyto) if($replyto);
  $replyto=$from if(!$replyto&&$from=~/.+\@.+\.\w{2,3}/&&$from!~/anonymous/i);
  $subject=&jconv($subject) if($subject);
  if($basecontenttype=~/multipart\/mixed/&&$boundary=~/kiritorisen/){$basecontenttype="postpet";$boundary=""}
  if($basecontenttype=~/multipart\/alternative|related/){$basecontenttype="html";$boundary=""}
  $mheader="$size\0$article\0$articles\0$date\0$subject\0$from\0$to\0$replyto\0$cc\0$basecontenttype\0";
  $mheader.="attachment" if($boundary);
  $count++;
  $num=$count+100;
  $mailbox{$num}=$mheader."\0";
  $from=$to=$replyto=$cc=$subject=$mimeversion=$boundary=$basecontenttype=""
}
sub getbody{
  local($pop3severname,$loginid,$password,$enum,$code,$savedir)=@_;
  local(*mailbox,$limit);
  if(!$pop3severname||!$loginid||!$password){$mailbox{errorcode}="$errorlevel\0";return %mailbox}
  $code="sjis" if(!$code||$code!~/^(euc|jis|sjis)$/);
  if($enum eq"all"){$article=1}
  else{$article=$enum}
  $limit=(time+90);
  if($savedir){open(F,"$savedir/attachfile");
  @chkline=<F>;
  for($i=0;$i<@chkline;$i++){
    if($chkline[$i]=~/(\d+),(.+)/&&($1<$limit||$2 eq"$loginid")){
      splice(@chkline,$i,1);
      unlink("$savedir/$2");
      $i--;
    }
  }
  open(F,">$savedir/attachfile");
  print F @chkline;
  close F}
  if($mailprotocol=&connectserver()){
  &serverlogin();
  close(remote_POP3);
  return %mailbox}
  if($articles&&$articles<$article){
    $article=1;
    &serverlogin();
  }
  $mailbox{errorcode}="$errorlevel\0";
  %mailbox;
}
sub serverlogin{
  select(remote_POP3); $|=1; select(STDOUT); $|=1;
  binmode(remote_POP3);
  $_=<remote_POP3>;
  print remote_POP3 "USER $loginid\r\n";
  if(&serveraccess){
  print remote_POP3 "PASS $password\r\n";
  if(&serveraccess){
  print remote_POP3 "LIST\r\n";
  $articles=&getmessagelist;
  $article=1 if($articles&&$articles<$article);
  if($articles&&$articles>=$article){
  print remote_POP3 "RETR $article\r\n";
  if(&getheader){
  &getmessagebody()}}}}
  print remote_POP3 "QUIT\r\n";
  &serveraccess;
}
sub getheader{
  do{$_=<remote_POP3>;
  $cont="" if(!/^\s/);
  if(/^message-id: (.+)$/i){$messageid=$1;$messageid=~/<?(.*)\@(.*)>?/;$messageid=$1}
  if(/^from: (.+)$/i){$from=$1;$cont=1}if(/^\s+(.+)$/&&$cont==1){$from.="$1"}
  if(/^to: (.+)$/i){$to=$1;$cont=2}elsif(/^\s+(.+)$/&&$cont==2){$to.="$1"}
  if(/^cc: (.+)$/i){$cc=$1;$cont=3}elsif(/^\s+(.+)$/&&$cont==3){$cc.="$1"}
  if(/^reply-to: (.+)/i){$replyto=$1;$cont=4}elsif(/^\s+(.+)$/&&$cont==4){$replyto.="$1"}
  if(/^subject: (.+)$/i){$subject=$1;$cont=5}elsif(/^\s+(.+)$/&&$cont==5){$subject.="$1"}
  if(/^date: (.+)$/i){$date=$1;$date=~s/\r\n|\r|\n//;$date=~s/, /,/;$date=~s/\+0900//}
  if(/^mime-version: (.+)$/i){$mimeversion=$1}
  if(/^content-type: (.+)$/i){$basecontenttype=$1}
  if(/boundary=\"(.+)\"/i){$boundary="$1";$boundary=~s/\*/%2a/g}
  if(/^content-transfer-encoding: (.+)$/i){$contentencoding=$1}
  $mailbox{header}.="$_" if(!/^\+OK/&&/\S/)}
  until(/^\r\n/);
  $from=~s/\"//g;
  $mailbox{total}="$articles";
  $mailbox{mailnum}="$article";
  $mailbox{date}="$date";
  $mailbox{subject}=&jconv($subject) if($subject);
  $mailbox{from}=&jconv($from) if($from);
  $mailbox{to}=&jconv($to) if($to);
  $mailbox{replyto}=&jconv($replyto) if($replyto);
  $mailbox{replyto}=$mailbox{from} if(!$replyto&&$from=~/.+\@.+\.\w{2,3}/&&$from!~/anonymous/i);
  $mailbox{cc}=&jconv($cc) if($cc);
  $basecontenttype="html" if($basecontenttype=~/multipart\/alternative|related/i);
  $mailbox{type}="$basecontenttype";
  $mailbox{boundary}="$boundary";
  $mailbox{header}=~s/(from:) .+\n([ \t].+\n)?/$1 $mailbox{from}\n/i;
  $mailbox{header}=~s/(to:) .+\n([ \t].+\n)?/$1 $mailbox{to}\n/i;
  $mailbox{header}=~s/(replyto:) .+\n([ \t].+\n)?/$1 $mailbox{replyto}\n/i;
  $mailbox{header}=~s/(cc:) .+\n([ \t].+\n)?/$1 $mailbox{cc}\n/i;
  $mailbox{header}=~s/(subject:) .*\n?([ \t].+\n)?([ \t].+\n)?/$1 $mailbox{subject}\n/i;
  $mailbox{message}=" ";
}
sub getmessagebody{
  $partflg=0;$mbody="";
  if($boundary=~/%2a|[()\[\]]/){
    $origiboundary="$boundary";
    $origiboundary=~s/([()\[\]])/\\$1/g;
    $boundary="bellcall_boundary1";
  }
  do{
  $_=<remote_POP3>;
  $textline++;
  $boundary2=$1 if(/boundary=\"(.+)\"/i);
  if($boundary2=~/[()\[\]]/){
    $origiboundary2="$boundary2";
    $origiboundary2=~s/([()\[\]])/\\$1/g;
    $boundary2="bellcall_boundary2";
  }
  if(/^--.*\*/&&($origiboundary=~/%2a/||$origiboundary2=~/%2a/)){s/\*/%2a/g;}
  s/^--$origiboundary/--$boundary/ if($origiboundary);
  s/^--$origiboundary2/--$boundary2/ if($origiboundary2);
  if($boundary){$bodytmp.=$_}
  else{
    if(/^begin\s\d{3}\s(.*)/i){
      $partflg++;
      $fencoding="uuencode";
      $filename=$1;
    }
    $filename=~s/\s//;
    if(!$partflg){s/^\.\./\./;$mbody.=$_}else{$fbody.=$_}
  }}until(/^\.\r\n/||$boundary&&/--$boundary--/);
  &msgdecode();
  if($bodytmp){
    if(!$boundary2){@pairs=split(/--$boundary/,$bodytmp)}
    else{@pairs=split(/--$boundary|--$boundary2/,$bodytmp)}
    foreach $pair(@pairs){
      ($header,$value)=split(/\r\n\r\n|\n\n/,$pair,2);
      next if($header!~/\S/||$value!~/\S/);
      (@header)=split(/\r\n|\n/,$header);
      if(!$contenttype){
        foreach $header(@header){
          $contenttype=$1 if($header=~/content-type: (.+);?/i);
          $contentencoding=$1 if($header=~/content-transfer-encoding: (.+)$/i);
          $charset=$1 if($header=~/charset="(.+)"$/i);
        }
        $mbody=$value;
        &msgdecode();
        $mailbox{charset}="$charset";
      }else{
        foreach $header(@header){
          $fn=0 if($header=~/^\w/||$header=~/=\"/);
          if($header=~/[e\s]name=(.+)/i){$filename=$1;$fn=1}
          elsif($fn&&$header=~/^\s/){$filename.=$header}
          $filename="htmlfile.htm" if(!$filename&&$basecontenttype eq"html");
          $fcontenttype=$1 if($header=~/content-type: (.+);?/i);
          $fencoding=$1 if($header=~/content-transfer-encoding: (.+)$/i);
          $fcid="$1" if($header=~/content-id: <(.+)>/i);
          $fcharset=$1 if($header=~/charset="(.+)"$/i);
        }
        $value=~s/\s?\.?\s+$/\n\n/;
        $fbody=$value if($filename!~/temp.ppd/);
      }
    }
  }
}
sub msgdecode{
  if($basecontenttype=~/urlencode/i||$contentencoding=~/urlencode/i){$mbody=&urldecode($mbody)}
  elsif($contentencoding=~/quoted-printable/i){$mbody=&qprdecode($mbody)}
  $mbody=~s/\x0D\x0A|[\x0D\x0A]/\n/g;
  $mbody=~s/\n\.\n//;
  $mbody=~s/^\n+//;
  $mbody=~s/\s+$//;
  $mbody=" \n$mbody ";
  $mbody=&jcode'to($code,$mbody) if($charset!~/us-ascii/i);
  $mailbox{message}="$mbody";
}
sub qprdecode{
  local($_)=shift;
  s/[^\S\r\n]*(\r?\n)/$1/g;
  s/\=\r?\n//g;
  s/=(..)/pack("H2",$1)/ge;
  $_;
}
sub urldecode{
  local($buffer)=@_;
  local($deco,$key,$value);
  @pairs=split(/&/,$buffer);
  foreach $pair(@pairs){
    ($key, $value)=split(/=/,$pair);
    $key=~tr/+/ /;
    $key=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
    $key=&jcode'to($code,$key);
    $value=~tr/+/ /;
    $value=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
    $value=&jcode'to($code,$value);
    $value=~s/\r\n/\n/g;
    $value=~s/\r/\n/g;
    $deco.="$key=$value\0";
  }
  $deco;
}
sub delmail{
  local($pop3severname,$loginid,$password,$enum)=@_;
  if($enum eq"all"){$article=1}else{$article=$enum}
  if($mailprotocol=&connectserver()){
    select(remote_POP3); $|=1; select(STDOUT); $|=1;
    $_=<remote_POP3>;
    print remote_POP3 "USER $loginid\r\n";
    if(&serveraccess){
      print remote_POP3 "PASS $password\r\n";
      if(&serveraccess){
        print remote_POP3 "LIST\r\n";
        if($articles=&getmessagelist){
          $errorlevel=1;
          print remote_POP3 "DELE $article\r\n"
        }
      }
    }
    print remote_POP3 "QUIT\r\n";
    &serveraccess;
    close(remote_POP3);
  }
  $mailbox{errorcode}=$errorlevel;
  %mailbox
}
1;

__END__

